/*********************************************
 * ReadShapefile VB.NET Example Project
 * 
 * Author: Kevin Bupp
 *         NVision Solutions, Inc.
 * 
 * Note that the demonstration version only
 * allows you to read/write 10 shapes.
 * 
 * This uses the NVS VB shapefile library
 * to read a user specified shapefile and display
 * the records in a detailed list view, then
 * allows the user to write that same shapefile out 
 * to a new location
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using nvsDemoVBShapefile;

namespace Simple_Example
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Shapefile shp;

		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		internal System.Windows.Forms.Button cmdSaveShapefile;
		internal System.Windows.Forms.Button cmdReadShapefile;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.ListView ListView1;
		private System.Windows.Forms.TextBox textBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.ListView1 = new System.Windows.Forms.ListView();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.cmdSaveShapefile = new System.Windows.Forms.Button();
			this.cmdReadShapefile = new System.Windows.Forms.Button();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Location = new System.Drawing.Point(8, 8);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(656, 368);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.ListView1);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(648, 342);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Shapefile Records";
			// 
			// ListView1
			// 
			this.ListView1.AllowColumnReorder = true;
			this.ListView1.FullRowSelect = true;
			this.ListView1.GridLines = true;
			this.ListView1.Location = new System.Drawing.Point(8, 8);
			this.ListView1.Name = "ListView1";
			this.ListView1.Size = new System.Drawing.Size(632, 328);
			this.ListView1.TabIndex = 0;
			this.ListView1.View = System.Windows.Forms.View.Details;
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.textBox1);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(648, 342);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Code";
			// 
			// textBox1
			// 
			this.textBox1.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(8, 8);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(632, 328);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "//other \'using\' statements for system variables\r\nusing nvsDemoVBShapefile;\r\n\r\nnam" +
				"espace Simple_Example\r\n{\r\n  public class Form1 : System.Windows.Forms.Form\r\n  {\r" +
				"\n    private Shapefile shp;\r\n\r\n    //C# stuff\r\n    // ...\r\n    //\r\n\r\n    private" +
				" void cmdReadShapefile_Click(object sender, System.EventArgs e)\r\n    {\r\n      op" +
				"enFileDialog1.Filter = \"*.shp|*.shp\";\r\n      openFileDialog1.FilterIndex = 0;\r\n\r" +
				"\n      //If the user selected a shapefile and did not cancel the open file dialo" +
				"g \r\n      if (DialogResult.Cancel != openFileDialog1.ShowDialog()) \r\n      {\r\n  " +
				"      //Create a new shapefile.  With COM Objects in VB.NET you declare the \r\n  " +
				"      //object and instantiate it using the object class as shown below.\r\n      " +
				"  shp = new ShapefileClass();\r\n\r\n        //Get the filename from the open file d" +
				"ialog and read\r\n        string f = openFileDialog1.FileName;\r\n\r\n        //C# req" +
				"uires us to create variables that we can ref to send the COM functions\r\n        " +
				"string basePath = f.Substring(0, f.LastIndexOf(\"\\\\\"));\r\n        string filename " +
				"= f.Substring(f.LastIndexOf(\"\\\\\") + 1);\r\n        //Read the shapefile into memor" +
				"y\r\n        shp.readShapefile(ref basePath, ref filename);\r\n        \r\n        //C" +
				"reate the table headers using the shapefile table description\r\n        //Note th" +
				"at we use the for each method to iterate through all of \r\n        //the table de" +
				"scriptors\r\n        TableDescriptor td;\r\n        ListView1.Columns.Clear();\r\n    " +
				"    //This would be the first part where C# differs from VB.NET:\r\n        //Sinc" +
				"e C# does not support Property\'s you need to directy\r\n        // call the access" +
				"or methods\r\n        for (short i = 0; i < shp.get_TableDescription().DescriptorC" +
				"ount; i++)\r\n        {\r\n          td = shp.get_TableDescription().getTableDescrip" +
				"torByIndex(ref i);\r\n          if (td.get_fieldType() == FieldTypeConstants.nvsFi" +
				"eldTypeCharacter)\r\n            ListView1.Columns.Add(td.get_name(), 50, Horizont" +
				"alAlignment.Left);\r\n          else if (td.get_fieldType() == FieldTypeConstants." +
				"nvsFieldTypeDate)\r\n            ListView1.Columns.Add(td.get_name(), 50, Horizont" +
				"alAlignment.Center);\r\n          else if (td.get_fieldType() == FieldTypeConstant" +
				"s.nvsFieldTypeLogical)\r\n            ListView1.Columns.Add(td.get_name(), 50, Hor" +
				"izontalAlignment.Right);\r\n          else //if (td.fieldType == FieldTypeConstant" +
				"s.nvsFieldTypeNumber\r\n            ListView1.Columns.Add(td.get_name(), 50, Horiz" +
				"ontalAlignment.Right);\r\n        }\r\n\r\n        //Iterate through all the ShapeObje" +
				"cts and add the record values for \r\n        //each table descriptor using the co" +
				"lumn \r\n        ShapeObject shpObj;\r\n        ListViewItem item;\r\n        string c" +
				"ol;\r\n        ListView1.Items.Clear();\r\n        for (short i = 1; i < shp.get_Sha" +
				"peObjects().Count(); i++)\r\n        {\r\n          shpObj = shp.getShapeObject(ref " +
				"i);\r\n          item = new ListViewItem();\r\n          col = ListView1.Columns[0]." +
				"Text;\r\n          item.SubItems[0].Text = shpObj.get_Record().getFieldByName(ref " +
				"col).get_value().Trim();\r\n          for (int j = 1; j < ListView1.Columns.Count;" +
				" j++)\r\n          {\r\n            col = ListView1.Columns[j].Text;\r\n            it" +
				"em.SubItems.Add(shpObj.get_Record().getFieldByName(ref col).get_value().Trim());" +
				"\r\n          }\r\n          ListView1.Items.Add(item);\r\n        }\r\n\r\n        //Refr" +
				"esh our listview to reflect the changes we have made\r\n        ListView1.Update()" +
				";\r\n\r\n        //Enable the save button\r\n        if (shp != null)\r\n          cmdSa" +
				"veShapefile.Enabled = true;\r\n      }\r\n    }\r\n\r\n    private void cmdSaveShapefile" +
				"_Click(object sender, System.EventArgs e)\r\n    {\r\n      if (shp != null)\r\n      " +
				"{\r\n        saveFileDialog1.Filter = \"*.shp|*.shp\";\r\n        saveFileDialog1.Filt" +
				"erIndex = 0;\r\n\r\n        //If the user selected a shapefile and did not cancel th" +
				"e open file dialog \r\n        if (saveFileDialog1.ShowDialog() != DialogResult.Ca" +
				"ncel)\r\n        {\r\n          //Get the filename from the open file dialog\r\n      " +
				"    string f = saveFileDialog1.FileName;\r\n\r\n          //Write the shapefile to t" +
				"he desired location\r\n          string basePath = f.Substring(0, f.LastIndexOf(\"\\" +
				"\\\"));\r\n          string filename = f.Substring(f.LastIndexOf(\"\\\\\") + 1);\r\n      " +
				"    if (shp.writeShapefile(ref basePath, ref filename))\r\n            MessageBox." +
				"Show(\"Shapefile save successfully.\", \"SUCCESS\", MessageBoxButtons.OK, MessageBox" +
				"Icon.Information);\r\n          else\r\n            MessageBox.Show(\"Eror while proc" +
				"essing shapefile.\", \"ERROR\", MessageBoxButtons.OK, MessageBoxIcon.Hand);\r\n      " +
				"  }\r\n      }\r\n      else\r\n      {\r\n        cmdSaveShapefile.Enabled = false;\r\n  " +
				"    }\r\n    }\r\n  }\r\n}";
			this.textBox1.WordWrap = false;
			// 
			// cmdSaveShapefile
			// 
			this.cmdSaveShapefile.Enabled = false;
			this.cmdSaveShapefile.Location = new System.Drawing.Point(384, 384);
			this.cmdSaveShapefile.Name = "cmdSaveShapefile";
			this.cmdSaveShapefile.Size = new System.Drawing.Size(128, 32);
			this.cmdSaveShapefile.TabIndex = 7;
			this.cmdSaveShapefile.Text = "Save Shapefile";
			this.cmdSaveShapefile.Click += new System.EventHandler(this.cmdSaveShapefile_Click);
			// 
			// cmdReadShapefile
			// 
			this.cmdReadShapefile.Location = new System.Drawing.Point(160, 384);
			this.cmdReadShapefile.Name = "cmdReadShapefile";
			this.cmdReadShapefile.Size = new System.Drawing.Size(128, 32);
			this.cmdReadShapefile.TabIndex = 6;
			this.cmdReadShapefile.Text = "Read Shapefile";
			this.cmdReadShapefile.Click += new System.EventHandler(this.cmdReadShapefile_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 421);
			this.Controls.Add(this.cmdSaveShapefile);
			this.Controls.Add(this.cmdReadShapefile);
			this.Controls.Add(this.tabControl1);
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(680, 448);
			this.MinimumSize = new System.Drawing.Size(680, 448);
			this.Name = "Form1";
			this.Text = "Simple C# Example";
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void cmdReadShapefile_Click(object sender, System.EventArgs e)
		{
			openFileDialog1.Filter = "*.shp|*.shp";
			openFileDialog1.FilterIndex = 0;

			//If the user selected a shapefile and did not cancel the open file dialog 
			if (DialogResult.Cancel != openFileDialog1.ShowDialog()) 
			{
				//Create a new shapefile.  With COM Objects in VB.NET you declare the 
				//object and instantiate it using the object class as shown below.
				shp = new ShapefileClass();

				//Get the filename from the open file dialog and read
				string f = openFileDialog1.FileName;

				//C# requires us to create variables that we can ref to send the COM functions
				string basePath = f.Substring(0, f.LastIndexOf("\\"));
				string filename = f.Substring(f.LastIndexOf("\\") + 1);
				//Read the shapefile into memory
				shp.readShapefile(ref basePath, ref filename);
	      
				//Create the table headers using the shapefile table description
				//Note that we use the for each method to iterate through all of 
				//the table descriptors
				TableDescriptor td;
				ListView1.Columns.Clear();
				//This would be the first part where C# differs from VB.NET:
				//Since C# does not support Property's you need to directy
				// call the accessor methods
				for (short i = 0; i < shp.get_TableDescription().DescriptorCount; i++)
				{
					td = shp.get_TableDescription().getTableDescriptorByIndex(ref i);
					if (td.get_fieldType() == FieldTypeConstants.nvsFieldTypeCharacter)
						ListView1.Columns.Add(td.get_name(), 50, HorizontalAlignment.Left);
					else if (td.get_fieldType() == FieldTypeConstants.nvsFieldTypeDate)
						ListView1.Columns.Add(td.get_name(), 50, HorizontalAlignment.Center);
					else if (td.get_fieldType() == FieldTypeConstants.nvsFieldTypeLogical)
						ListView1.Columns.Add(td.get_name(), 50, HorizontalAlignment.Right);
					else //if (td.fieldType == FieldTypeConstants.nvsFieldTypeNumber
						ListView1.Columns.Add(td.get_name(), 50, HorizontalAlignment.Right);
				}

				//Iterate through all the ShapeObjects and add the record values for 
				//each table descriptor using the column 
				ShapeObject shpObj;
				ListViewItem item;
				string col;
				ListView1.Items.Clear();
				for (short i = 1; i < shp.get_ShapeObjects().Count(); i++)
				{
					shpObj = shp.getShapeObject(ref i);
					item = new ListViewItem();
					col = ListView1.Columns[0].Text;
					item.SubItems[0].Text = shpObj.get_Record().getFieldByName(ref col).get_value().Trim();
					for (int j = 1; j < ListView1.Columns.Count; j++)
					{
						col = ListView1.Columns[j].Text;
						item.SubItems.Add(shpObj.get_Record().getFieldByName(ref col).get_value().Trim());
					}
					ListView1.Items.Add(item);
				}

				//Refresh our listview to reflect the changes we have made
				ListView1.Update();

				//Enable the save button
				if (shp != null)
					cmdSaveShapefile.Enabled = true;
			}
		}

		private void cmdSaveShapefile_Click(object sender, System.EventArgs e)
		{
			if (shp != null)
			{
				saveFileDialog1.Filter = "*.shp|*.shp";
				saveFileDialog1.FilterIndex = 0;

				//If the user selected a shapefile and did not cancel the open file dialog 
				if (saveFileDialog1.ShowDialog() != DialogResult.Cancel)
				{
					//Get the filename from the open file dialog
					string f = saveFileDialog1.FileName;

					//Write the shapefile to the desired location
					string basePath = f.Substring(0, f.LastIndexOf("\\"));
					string filename = f.Substring(f.LastIndexOf("\\") + 1);
					if (shp.writeShapefile(ref basePath, ref filename))
						MessageBox.Show("Shapefile save successfully.", "SUCCESS", MessageBoxButtons.OK, MessageBoxIcon.Information);
					else
						MessageBox.Show("Eror while processing shapefile.", "ERROR", MessageBoxButtons.OK, MessageBoxIcon.Hand);
				}
			}
			else
			{
				cmdSaveShapefile.Enabled = false;
			}
		}
	}
}
