VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Read and Describe a shapefile"
   ClientHeight    =   4740
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8190
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4740
   ScaleWidth      =   8190
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   375
      Left            =   6720
      TabIndex        =   8
      Top             =   4320
      Width           =   1335
   End
   Begin VB.Frame recordsFrame 
      Caption         =   "Records"
      Height          =   3975
      Left            =   4920
      TabIndex        =   5
      Top             =   0
      Width           =   3255
      Begin VB.ListBox List2 
         Height          =   3570
         ItemData        =   "Form1.frx":058A
         Left            =   120
         List            =   "Form1.frx":058C
         TabIndex        =   6
         Top             =   240
         Width           =   3015
      End
   End
   Begin VB.Frame shpObjFrame 
      Caption         =   "Shape Objects"
      Height          =   3975
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   2175
      Begin VB.ListBox List1 
         Height          =   3570
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.Frame bboxFrame 
      Caption         =   "Bounding Box"
      Height          =   1215
      Left            =   2280
      TabIndex        =   0
      Top             =   0
      Width           =   2535
      Begin VB.Label lblBBox 
         Height          =   855
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   2295
         WordWrap        =   -1  'True
      End
   End
   Begin VB.Frame pointsFrame 
      Caption         =   "Points"
      Height          =   2775
      Left            =   2280
      TabIndex        =   1
      Top             =   1200
      Width           =   2535
      Begin VB.ListBox List3 
         Height          =   2400
         Left            =   120
         TabIndex        =   2
         Top             =   215
         Width           =   2295
      End
   End
   Begin VB.Label Label1 
      Caption         =   $"Form1.frx":058E
      Height          =   615
      Left            =   120
      TabIndex        =   7
      Top             =   4080
      Width           =   6735
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''
' ReadShapefile VB Example Project
'
' Author: Kevin Bupp
'         NVision Solutions, Inc.
'
' Note that the demonstration version only
' allows you to read 10 shapes.
'
' This uses the NVS VB shapefile library
' to read the STATES shapefile located in
' this same directory and then lists all of
' its ShapeObjects.  Once a shapeObject is
' selected from the list its points, records,
' type, and bouding box are described.
''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'This is a windows function call that will allow us to tabularize a list box
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal _
    hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Const LB_SETTABSTOPS = &H192 'A parameter constant used in the function above

Private shp As Shapefile 'We will go ahead and set this a global variable in this form

'This procedure uses the function we declared to set the tab marks in the listbox
Private Sub ListBoxSetTabStops(lb As ListBox, tabStops() As Long)
    Dim numEls As Long
    numEls = UBound(tabStops) - LBound(tabStops) + 1
    SendMessage lb.hwnd, LB_SETTABSTOPS, numEls, tabStops(LBound(tabStops))
End Sub

'For when we are done ... a little cleanup
Private Sub cmdClose_Click()
  Set shp = Nothing
  End
End Sub

'This event procedure fires off when you run the program
Private Sub Form_Load()
  Dim shpBasePath As String
  Dim shpFilename As String
  Dim i As Integer
  
  'Specify the file on disk that you want to read and describe
  shpBasePath = App.Path
  shpFilename = "STATES"
  
  'set our global shapefile variable to a new shapefile object
  Set shp = New Shapefile
  
  'Read in all the parts, points, and records from the desired shapefile on disk
  shp.ReadShapefile shpBasePath, shpFilename
  
  'clear our shape object list
  List1.Clear
  
  'modify the frame caption to reflect the number of shapes in this shapefile
  shpObjFrame.Caption = "Shape Objects (" & shp.ShapeObjectCount & ")"
  
  'Loop through all of the points and add a short descriptor to the list
  For i = 1 To shp.ShapeObjectCount
    Select Case shp.ShapeType
      Case nvsPoint
        List1.AddItem "Point " & i
      Case nvsMultiPoint
        List1.AddItem "MultiPoint " & i
      Case nvsPolyLine
        List1.AddItem "PolyLine " & i
      Case nvsPolygon
        List1.AddItem "Polygon " & i
      Case Else
        List1.AddItem "Undefined " & i
    End Select
  Next
  
  'Set the tab stop for our record list box
  Dim tabs(0) As Long
  tabs(0) = 65
  ListBoxSetTabStops List2, tabs()
End Sub

'This event is executed whenever the user clicks on an item in the shape object list
Private Sub List1_Click()
  'Declare a ShapeObject and set it to the selected shape in the list
  Dim shpObj As ShapeObject
  Set shpObj = shp.getShapeObject(List1.ListIndex + 1)
  
  'Compute the extents so that we can gather information about the bounding box
  shpObj.computeExtents
  'Display Bounding Box information
  lblBBox.Caption = "X Maximum: " & Format(shpObj.BoundingBox.xMax, "#0.000000") & vbCrLf & _
                    "Y Maximum: " & Format(shpObj.BoundingBox.yMax, "#0.000000") & vbCrLf & _
                    "X Minimum: " & Format(shpObj.BoundingBox.xMin, "#0.000000") & vbCrLf & _
                    "Y Minimum: " & Format(shpObj.BoundingBox.yMin, "#0.000000")
  
  Dim i As Integer
  Dim j As Integer
  j = 1
  List3.Clear 'clear the list
  'Change the frame caption to show both the total num,ber of points and the number of parts
  pointsFrame.Caption = "Points (" & shpObj.CoordinateCount & "), " & shpObj.PartCount & " parts"
  'Loop through all of the points and add their coordinates to the list
  For i = 1 To shpObj.CoordinateCount
    If j <= shpObj.PartCount Then
      'If we are starting a new part, add a new "part start" statement to the list.
      If i - 1 = shpObj.getPart(j) Then
        List3.AddItem "Part " & j & ":"
        j = j + 1
      End If
    End If
    'Add the coordinate information to the list in a (x,y) format
    List3.AddItem "(" & Format(shpObj.getCoord(i).X, "#0.000000") & "," & _
                        Format(shpObj.getCoord(i).Y, "#0.000000") & ")"
  Next
  
  Dim fld As RecordField 'declare a record field object
  List2.Clear 'clear the list
  'Change the frame caption to reflect the number of fields
  recordsFrame.Caption = "Records (" & shpObj.Record.FieldCount & " fields)"
  'Note: the fieldcount should always be the same as long as you are in the same shapefile.
  'Also, the record field names should match those in the TableDescriptor for the shapefile
  For i = 1 To shpObj.Record.FieldCount
    'set the record field object
    Set fld = shpObj.Record.getFieldByIndex(i)
    
    'add the record field information to the tabbed list
    List2.AddItem Trim(fld.Name) & vbTab & Trim(fld.Value)
  Next
End Sub
